#include "B4RDefines.h"

B4R::Serial* b4r_main::_serial1;
B4R::B4MFRC522* b4r_main::_rfid;
B4R::ByteConverter* b4r_main::_bc;
static B4R::Serial be_gann1_3;
static B4R::B4MFRC522 be_gann2_3;
static B4R::ByteConverter be_gann3_3;


 void b4r_main::_appstart(){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 14;BA.debugLine="Private Sub AppStart";
 //BA.debugLineNum = 15;BA.debugLine="Serial1.Initialize(115200)";
b4r_main::_serial1->Initialize((ULong) (115200));
 //BA.debugLineNum = 16;BA.debugLine="Log(\"AppStart\")";
B4R::Common::LogHelper(1,102,F("AppStart"));
 //BA.debugLineNum = 17;BA.debugLine="rfid.Initialize(10, 9, \"rfid_CardPresent\")";
b4r_main::_rfid->Initialize((Byte) (10),(Byte) (9),_rfid_cardpresent);
 //BA.debugLineNum = 18;BA.debugLine="rfid.LogVersion";
b4r_main::_rfid->LogVersion();
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}

void b4r_main::initializeProcessGlobals() {
     B4R::StackMemory::buffer = (byte*)malloc(STACK_BUFFER_SIZE);
     b4r_main::_process_globals();

   
}
void b4r_main::_process_globals(){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 8;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 9;BA.debugLine="Public Serial1 As Serial";
b4r_main::_serial1 = &be_gann1_3;
 //BA.debugLineNum = 10;BA.debugLine="Private rfid As MFRC522";
b4r_main::_rfid = &be_gann2_3;
 //BA.debugLineNum = 11;BA.debugLine="Private bc As ByteConverter";
b4r_main::_bc = &be_gann3_3;
 //BA.debugLineNum = 12;BA.debugLine="End Sub";
}
void b4r_main::_rfid_cardpresent(B4R::Array* _uid,Byte _cardtype){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 21;BA.debugLine="Sub rfid_CardPresent (UID() As Byte, CardType As B";
 //BA.debugLineNum = 22;BA.debugLine="Log(\"UID: \", bc.HexFromBytes(UID))";
B4R::Common::LogHelper(2,102,F("UID: "),101,b4r_main::_bc->HexFromBytes(_uid)->data);
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}
